-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Abstract button"
	interface: abstract, inheritance

deferred class BUTTON

inherit
	DIALOG_ELEMENT
		end

feature {NONE}
	
	command: GUI_COMMAND

feature -- Status

	set_label (label: STRING) is
			-- Set the button's displayed label.
		require
			valid: label /= Void
		deferred
		end

feature -- Command
	
	set_command (gc: GUI_COMMAND) is
			-- Set when_executed command.
		require
			nothing: -- Void means no command
		do
			command := gc
		ensure
			keep_reference: command = gc
		end

feature {PUBLIC_NONE} -- Event

	when_executed is
			-- Button clicked.
			-- Default: use command.
		do
			if command /= Void then
				command.execute
			end
		end

end -- class BUTTON
