-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "(Internal) Base implementation window for CONTROLs"
	interface: inheritance, client

class CONTROL_WINDOW

inherit
	CHILD_WINDOW
		redefine
			when_character_entered, when_key_pressed
		end
	
creation
	-- effectively deferred 

feature {PUBLIC_NONE}
	
	control: CONTROL

feature
	
	set_control (ctl: like control) is
			-- Set associated control.
		require
			valid: ctl /= Void
		do
			control := ctl
		ensure
			keep_reference: ctl = control
		end

feature {PUBLIC_NONE} -- Window event(s), keyboard

	when_character_entered, frozen control_when_character_entered (c: CHARACTER) is
			-- Character entered (implements dialog keyboard interface).
		local
			vkey: VIRTUAL_KEY
		do
			check valid_control: control /= Void end

			!!vkey.make
			vkey.set_alt

			if vkey.is_key_down then
				control.when_hotkey (c) -- search hotkey
			end
		end
		
	when_key_pressed, frozen control_when_key_pressed (key: VIRTUAL_KEY) is
			-- Vkey entered (implements dialog keyboard interface).
		local
			shift: VIRTUAL_KEY
		do
			check valid_control: control /= Void end

			!!shift.make
			shift.set_shift

			if key.is_tab then
				if shift.is_key_down then
					control.when_shift_tab
				else
					control.when_tab
				end
			end

			if key.is_return then
				control.when_enter
			end
			if key.is_escape then
				control.when_escape
			end
			if key.is_cursor_down then
				control.when_down
			end
			if key.is_cursor_up then
				control.when_up
			end
		end

end -- class CONTROL_WINDOW
