-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "A string item for a list box"
	interface: client

class LISTBOX_STRING

inherit
	LISTBOX_ITEM
		end

creation
	make

feature -- Item's name

	is_valid: BOOLEAN is
			-- Is this item valid?
		do
			Result := name /= Void
		end

	name: STRING
			-- Listbox item's name.

feature
	
	make, set_name (s: STRING) is
			-- Set listbox item's name.
		require
			valid: s /= Void
		do
			if name = Void then
				!!name.make (0)
			end
			name.copy (s)
		ensure
			name_set: name.is_equal (s)
		end

end -- class LISTBOX_STRING
