-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in check box"
	interface: client, inheritance

class STD_CHECKBOX

inherit
	STD_BUTTON
		redefine
			default_height
		end
	CHECKBOX
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (par: WINDOW) is
			-- Create the button.
		do
			!!self.make_handle (par, wrt.win_but_ccheck (par.handle))
			register
		end

feature -- Status
			
	is_checked: BOOLEAN is
			-- Is the button checked?
		do
			Result := wrt.win_msg_bool (self.handle, wrt.Bm_getcheck)
		end

	check_mark is
			-- Set the check mark to checked status.
		do
			internal_check_mark
		end
	
	uncheck_mark is
			-- Set the check mark to unchecked status.
		do
			wrt.win_msg_setbool (self.handle, wrt.Bm_setcheck, false)
		end

feature {NONE} -- (Internal)
	
	internal_check_mark is
			-- Check mark (usable by descendants).
		do
			wrt.win_msg_setbool (self.handle, wrt.Bm_setcheck, true)
		end

feature -- Size

	adapt_width is
			-- Adapt width to label text.
			-- (based on estimate in independent coordinates)
		do
			indep_set_width (estimate_width (self.text)+14) -- 3.5 "characters" for checkbox
		end

feature {PUBLIC_NONE} -- Default size

	default_height: INTEGER is
			-- Line height.
		do
			Result := 10
		end

end -- class STD_CHECKBOX
