-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in group box (frame with a label holding other controls)"
	interface: client

class STD_GROUP_BOX

inherit
	STD_STATIC
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (p: WINDOW) is
			-- Create control.
		do
			!!self.make_handle (p, wrt.win_but_cgroupbox (p.handle))
			register
		end

feature {NONE}
		
	Groupbox_interspace: INTEGER is 6
			-- Space beetween controls and borders.

	First_control: INTEGER is 12
			-- First control vertical offset.

feature -- Positionning

	arrange_first (ctl: DIALOG_ELEMENT) is
			-- Position first control inside the group box.
		require
			valid: ctl /= Void
		local
			pt: POINT
		do
			!!pt.make_coord (Groupbox_interspace + indep_size.lower.x, 
							First_control + indep_size.lower.y)
			ctl.indep_set_point (pt)
			arrange (ctl)
		end

	arrange (ctl: DIALOG_ELEMENT) is
			-- Resize groupbox so that 'ctl' is inside.
		require
			valid: ctl /= Void
		local
			csize, wsize: RECTANGLE
		do
			csize := ctl.indep_size
			wsize := indep_size
			if csize.is_inside (wsize) = false then -- control outside group box.
				if csize.upper.x > wsize.upper.x - Groupbox_interspace then
					wsize.set_upper_x (csize.upper.x + Groupbox_interspace)
				end
				if csize.upper.y > wsize.upper.y - Groupbox_interspace then
					wsize.set_upper_y (csize.upper.y + Groupbox_interspace)
				end
			end
			indep_set_size (wsize)
		end
	
feature -- Label

	set_label (str: STRING) is
			-- Set the label name which will be displayed.
		require
			valid: str /= Void
		do
			set_text (str)
		end

end -- class STD_GROUP_BOX
