-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in static text control"
	interface: client

class STD_LABEL

inherit
	STD_STATIC
		redefine
			default_height
		end

creation
	make, make_left, make_center

feature {CREATION_NONE} -- Creation
	
	make (p: WINDOW) is
			-- Create standard simple label (left justified, one-line).
		do
			!!self.make_handle (p, wrt.win_static_create (p.handle, wrt.Ss_simple))
			register
		end

	make_left (p: WINDOW) is
			-- Create label with left-aligned, wordwrapped text.
		require
			valid: p /= Void
		do
			!!self.make_handle (p, wrt.win_static_create (p.handle, wrt.Ss_left))
			register
		end

	make_center (p: WINDOW) is
			-- Create label with centre centred and wordwrapped text.
		require
			valid: p /= Void
		do
			!!self.make_handle (p, wrt.win_static_create (p.handle, wrt.Ss_center))
			register
		end
	
feature {PUBLIC_NONE} -- Default size

	default_height: INTEGER is
		do
			Result := 10
		end

feature -- Label

	set_label (str: STRING) is
			-- Set the label name which will be displayed.
		require
			valid: str /= Void
		do
			set_text (str)
		end

	adapt_width is
			-- Adapt width to label text.
			-- (based on estimate in independent coordinates)
		do
			indep_set_width (estimate_width (self.text))
		end

end -- class STD_LABEL
