-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in scrollbar control"
	interface: client, inheritance

class STD_SCROLLBAR

inherit
	STD_CONTROL
		redefine
			std_control_when_scroll,
			default_height
		end
	DIALOG_SCROLLBAR
		end
	BASE_SCROLLBAR
		end

creation
	make_horizontal, make_vertical

feature {CREATION_NONE} -- Creation

	make, make_horizontal (par: WINDOW) is
		do
			is_horizontal := true
			type := wrt.Sb_ctl
			make_scroll (par)
		end

	make_vertical (par: WINDOW) is
		require
			valid: par /= Void
		do
			is_horizontal := false
			type := wrt.Sb_ctl
			make_scroll (par)
		end

feature {NONE} -- Handle

	sb_handle: INTEGER is
		do
			Result := self.handle
		end

feature {NONE} -- Creation

	make_scroll (p: WINDOW) is
		do
			!!self.make_handle (p, wrt.win_scroll_create (p.handle, is_horizontal))
			register
			init
		end

feature -- Direction

	is_horizontal: BOOLEAN;
			-- Is this scrollbar horizontal?

feature -- Default size

	default_height: INTEGER is
		do
			Result := 10
		end

feature {NOTIFIER} -- Internal event implementation 

	std_control_when_scroll (code: INTEGER; position: INTEGER) is
		require else
			redefined: true
		do
			scrollbar_event (code, position)
		end

end -- class STD_SCROLLBAR
