-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Abstract control that holds a text (multiple lines)"
	interface: abstract, inheritance

deferred class TEXTBOX

inherit
	DIALOG_ELEMENT
		end

feature -- Contents

	contents: P_LIST[STRING] is
			-- Associated text.
		deferred
		ensure
			not_void: contents /= Void
			is_copy: -- copy of contents
		end

	set_contents (c: P_LIST[STRING]) is
			-- Set associated text.
		require
			valid_contents: c /= Void
		deferred
		ensure
			coherent: c.is_equal (contents) -- logical copy only
		end

end -- class TEXTBOX
