-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Specialised drawable rectangle for GUI"
	comment: "Device must be in text mode"
	interface: client

class DRAWABLE_GUI_RECTANGLE

inherit
	DRAWABLE_RECTANGLE
		rename
			make as old_make
		redefine
			draw
		end

creation
	make

feature {CREATION_NONE}
	
	make is
			-- Creation.
		do
			type := Normal_rect
			old_make
		end

feature {NONE}
	
	type: INTEGER
	Normal_rect, Invert_rect, Focus_rect: INTEGER is unique

feature -- Type
	
	set_type_invert is
			-- Filled xor-ed rectangle.
		do
			type := Invert_rect
		end

	set_type_focus is
			-- Focus rectangle (dotted xor-ed frame).
		do
			type := Focus_rect
		end

	set_type_normal, reset_type is
			-- Default rectangle.
		do
			type := Normal_rect
		end

feature {GRAPHIC_DEVICE}
	
	draw (gd: GRAPHIC_DEVICE) is
		local
			x, y, x1, y1: INTEGER
		do
			check
				text_mode: --device in text mode
			end

			-- GDI does not draw the right and bottom sides, hence the +1 fix.
			x := position.lower.x
			y := position.lower.y
			x1 := position.upper.x+1
			y1 := position.upper.y+1

			inspect
				type
			when Normal_rect then
				wrt.win_gdi_rectangle (gd.handle, x, y, x1, y1)
			when Focus_rect then
				wrt.win_gdi_focusrect (gd.handle, x, y, x1, y1)
			when Invert_rect then
				wrt.win_gdi_invertrect (gd.handle, x, y, x1, y1)
			end
		end

end -- class DRAWABLE_GUI_RECTANGLE
