-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Draw a line"
	interface: client

class DRAWABLE_LINE

inherit
	DRAWABLE
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make is
		do
		end

feature {NONE} -- Line definition
	
	start_x, start_y, final_x, final_y: INTEGER

feature -- Set line definition 
	
	set_start (pt: POINT) is
			-- Set line starting point.
		require
			valid_point: pt /= Void
		do
			start_x := pt.x
			start_y := pt.y
		end

	set_final (pt: POINT) is
			-- Set line ending point (the line will be 
			-- drawn up to but not including this point).
		require
			valid_point: pt /= Void
		do
			final_x := pt.x
			final_y := pt.y
		end
	
feature {GRAPHIC_DEVICE}
	
	draw (dc: GRAPHIC_DEVICE) is
		do
			wrt.win_gdi_line (dc.handle, start_x, start_y, final_x, final_y)
		end

end -- class DRAWABLE_LINE
