-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Drawable point (pixel)"
	interface: client

class DRAWABLE_POINT

inherit
	DRAWABLE
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make is
		local
			rgb: RGB_COLOR
		do
			!!rgb.black
			set_color (rgb)
		end

feature {NONE} -- Internal position

	position_x, position_y: INTEGER
	color: INTEGER

feature -- Position
	
	set_position (pt: POINT) is
			-- Set point/pixel position.
		require
			valid: pt /= Void
		do
			position_x := pt.x
			position_y := pt.y
		end

	set_color (clr: COLOR) is
			-- Set point/pixel colour.
			-- (This class does not use the current pen).
		require
			valid: clr /= Void
		do
			color := clr.to_windows
		end

feature {GRAPHIC_DEVICE} -- Drawing

	draw ( gd: GRAPHIC_DEVICE ) is
		do
			wrt.win_gdi_setpixel (gd.handle, position_x, position_y, color)
		end

end -- class DRAWABLE_POINT
