-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Graphic drawing mode for raster devices"
	interface: client

class GRAPHIC_MODE

inherit
	WIN_API
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make is
			-- Create graphic mode.
		do
			mode := wrt.R2_copypen
		end

feature -- Modes

	black is
			-- Pixel always black.
		do
			mode := wrt.R2_black
		end

	white is
			-- Pixel always white.
		do
			mode := wrt.R2_white
		end

	pen is
			-- Pixel is pen colour (default).
		do
			mode := wrt.R2_copypen
		end

	inverse is
			-- Pixel is the inverse of the screen colour.
		do
			mode := wrt.R2_not
		end

	nothing is
			-- Do nothing.
		do
			mode := wrt.R2_nop
		end

	inverse_pen is
			-- Pixel is the inverse of the pen colour.
		do
			mode := wrt.R2_notcopypen
		end

	merge is
			-- Combine screen and pen colour.
		do
			mode := wrt.R2_mergepen
		end

feature {NONE}
	
	mode: INTEGER

feature {GRAPHIC_DEVICE}
	
	to_windows: INTEGER is
		do
			Result := mode
		end

end -- class GRAPHIC_MODE
