-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "System font(s)"
	interface: client

class SYSTEM_FONT

inherit
	FONT
		end

creation
	make, make_gui

creation {SYSTEM_FONT}
	make_self

feature {CREATION_NONE}
	
	make is
			-- Standard system font.
		do
			type := wrt.System_font
		end

	make_gui is
			-- Default GUI system font.
		do
			type := wrt.Default_gui_font
		end

feature {NONE} -- Creation

	make_self (tp: INTEGER) is
			-- Duplicate.
		do
			type := tp
		ensure
			done: type = tp
		end

feature {NONE}
	
	type: INTEGER

feature {WIN_API}

	duplicate: FONT is
		do
			!SYSTEM_FONT!Result.make_self (type) 
		end

	to_windows (dc: GRAPHIC_DEVICE): WIN_FONT is
		do
			!!Result.make_stock (type)
		end

end -- class SYSTEM_FONT
