-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "(Internal) common pen features"
	interface: client, internal

deferred class BASIC_PEN

inherit
	PEN
		end
	WIN_API
		end

feature {NONE} -- Creation

	make_basic is
		do
			!RGB_COLOR!color.black
			set_line_solid
		end

feature {NONE}
	
	color: COLOR
	style: INTEGER

feature -- Colour
	
	set_color (cl: COLOR) is
			-- Set pen colour.
		require
			valid_color: cl /= Void
		do
			color := cl
		ensure
			keep_reference: color = cl
		end

feature -- Line style

	set_line_solid is
			-- Set line style: solid (default).
		do
			style := wrt.Ps_solid
		end

	set_line_solid_inside_frame is
			-- Set line style: solid, kept inside rectangles.
		do
			style := wrt.Ps_insideframe
		end

	set_line_invisible is
			-- Set line style: no line (invisible).
		do
			style := wrt.Ps_null
		end

	set_line_dash is
			-- Set line style: - - - -
		do
			style := wrt.Ps_dash
		end

	set_line_dot is
			-- Set line style: .......
		do
			style := wrt.Ps_dot
		end

	set_line_dash_dot is
			-- Set line style: -.-.-.-
		do
			style := wrt.Ps_dashdot
		end

	set_line_dash_dot_dot is
			-- Set line style: -..-..-
		do
			style := wrt.Ps_dashdotdot
		end

invariant
	valid_color: color /= Void

end -- class BASIC_PEN
