-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal
	description: "Configuration class of the library"
	interface: internal, mixin

class F_CONFIG inherit WIN_API end

feature
	
	Version: STRING is "0.10-beta"
			-- Version of the library.

	default_dialog_font: FONT is
			-- Default font used by dialog boxes.
		local
			lfont: LOGICAL_FONT
		do
			if wrt.win_ver_above (4, 0) then
				-- use system dialog font when available
				!SYSTEM_FONT!Result.make_gui
			else
				-- We could use default system font but it is 
				-- generally too big and cannot be changed trivially
				-- with win32 < 4.0. Dialogs default to hardcoded 
				-- font since Windows 3.1.
				
				!!lfont.make
				lfont.set_face_name ("MS Sans Serif")
				lfont.set_point (8)
				-- not bold with new ("grey") background
				Result := lfont
			end
		ensure
			valid_result: Result /= Void
		end

end -- class F_CONFIG
