-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal, Keyboard
	description: "(Internal) accelerator table"
	interface: client, internal

class WIN_ACCEL

inherit
	WIN_API

	WIN_RUNTIME_FINAL

	WIN_ACCEL_CONST

	WIN_OBJECT


creation {WIN_API}
	make

feature {NONE}
	
	make (items: P_LIST[MENU_ITEM]) is
			-- Create accelerator list from current list of menu items.
		require
			ok: items /= Void
		local
			it: P_ITERATOR[MENU_ITEM]
			cax, acc_table: F_MEMORY
			cidx, cnt: INTEGER
		do
			finalisation_register
			reset_handle
			!!acc_table.make (items.count * Accel_size) -- max size

			from
				it := items.iterator
				it.first

				cidx := 1 -- reset current index
			variant it.forward_variant until it.outside loop

				if it.item.has_accelerator then
					cax := it.item.accelerator_to_windows
				
					-- update table
					acc_table.set_subset (cidx, cax)
					check one_size_for_now: cax.size = Accel_size end
					cidx := cidx + Accel_size

					-- update count
					cnt := cnt + 1
				end
				
				-- next
				it.forth
			end

			if cnt > 1 then
				set_handle (wrt.win_accel_create (acc_table.subset (1, cidx-1).to_windows, cnt))
			end
		end

feature {NONE}
	
	dispose is
		do
			if handle /= Invalid_handle then
				win_accel_enable (Invalid_handle, Invalid_handle)
				win_accel_destroy (handle)
				handle := Invalid_handle
			end
		end
	
end -- class WIN_ACCEL
