-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal
	description: "Windows constants"
	interface: internal, client

class WIN_CONST

feature -- Win32 constants

	-- Button constants
	Bn_clicked: INTEGER is 0
	Bm_getcheck: INTEGER is 240 -- 0xF0
	Bm_setcheck: INTEGER is 241 -- 0xF1

	-- Listbox constants
	Lbn_selchange: INTEGER is 1
	Lbn_dblclk: INTEGER is 2
	Lbn_selcancel: INTEGER is 3
	Lbn_setfocus: INTEGER is 4
	Lbn_killfocus: INTEGER is 5
	Lbn_errspace: INTEGER is -2
	Lb_err: INTEGER is -1
	Lb_resetcontent: INTEGER is 388 -- 0x184
	Lb_setsel: INTEGER is 389 -- Ox185
	Lb_setcursel: INTEGER is 390 -- 0x186
	Lb_getcursel: INTEGER is 392 -- 0x188
	Lb_getselcount: INTEGER is 400 -- 0x190
	Lb_setanchorindex: INTEGER is 412 -- 0x19c
	Lb_setcaretindex: INTEGER is 414 -- 0x19e
	Lb_getcaretindex: INTEGER is 415 -- 0x19f

	-- Combobox constants
	Cbn_selchange: INTEGER is 1
	Cbn_dblclk: INTEGER is 2
	Cbn_setfocus: INTEGER is 3
	Cbn_killfocus: INTEGER is 4
	Cbn_editchange: INTEGER is 5
	Cbn_editupdate: INTEGER is 6
	Cbn_dropdown: INTEGER is 7
	Cbn_closeup: INTEGER is 8
	Cbn_selendok: INTEGER is 9
	Cbn_selendcancel: INTEGER is 10
	Cbn_errspace: INTEGER is -1
	Cb_getcursel: INTEGER is 327 -- 0x147
	Cb_setcursel: INTEGER is 334 -- 0X14e
	Cb_resetcontent: INTEGER is 331 -- 0x14b
	Cb_geteditsel: INTEGER is 320 -- 0x140

	-- Editbox constants
	En_change: INTEGER is 768 -- 0x300
	En_update: INTEGER is 1024 -- 0x400
	En_errspace: INTEGER is 1280 -- 0x500
	Em_getsel: INTEGER is 176 -- 0xB0
	Em_canundo: INTEGER is 198 -- 0xc6
	Em_undo: INTEGER is 199 -- 0xc7
	Em_getmodify: INTEGER is 184 -- 0xB8
	Em_setmodify: INTEGER is 185 -- 0xB9

	-- Scrollbar constants
	Sb_lineup: INTEGER is 0
	Sb_linedown: INTEGER is 1
	Sb_pageup: INTEGER is 2
	Sb_pagedown: INTEGER is 3
	Sb_thumbposition: INTEGER is 4
	Sb_thumbtrack: INTEGER is 5
	Sb_horz: INTEGER is 0
	Sb_vert: INTEGER is 1
	Sb_ctl: INTEGER is 2

	-- ShowWindow constants
	Sw_showdefault: INTEGER is 10
	Sw_shownormal: INTEGER is 1
	Sw_show: INTEGER is 5 
	Sw_hide: INTEGER is 0 
	Sw_restore: INTEGER is 9
	Sw_showminimized: INTEGER is 2
	Sw_showmaximized: INTEGER is 3

	-- Cursors constants
	Idc_appstarting: INTEGER is 32650
	Idc_arrow: INTEGER is 32512
	Idc_cross: INTEGER is 32515
	Idc_ibeam: INTEGER is 32513
	Idc_icon: INTEGER is 32641
	Idc_no: INTEGER is 32648
	Idc_uparrow: INTEGER is 32516
	Idc_wait: INTEGER is 32514
	Idc_sizenwse: INTEGER is 32642
	Idc_sizenesw: INTEGER is 32643
	Idc_sizewe: INTEGER is 32644
	Idc_sizens: INTEGER is 32645
	Idc_sizeall: INTEGER is 32646

	-- Static controls constants
	Ss_simple: INTEGER is 11 -- 0xB
	Ss_center: INTEGER is 1
	Ss_left: INTEGER is 0 
	Ss_grayframe: INTEGER is 8
	Ss_grayrect: INTEGER is 5
	Ss_blackrect: INTEGER is 4
	Ss_blackframe: INTEGER is 7
	Ss_icon: INTEGER is 3
	
	-- GetStockObject constants
	Black_brush: INTEGER is 4
	Null_brush: INTEGER is 5
	White_brush: INTEGER is 0
	Black_pen: INTEGER is 7
	Null_pen: INTEGER is 8
	White_pen: INTEGER is 6
	Ansi_fixed_font: INTEGER is 11
	Ansi_var_font: INTEGER is 12
	Device_default_font: INTEGER is 14
	Oem_fixed_font: INTEGER is 10
	System_font: INTEGER is 13
	Default_gui_font: INTEGER is 17 -- WINVER > 0x0400
	Default_palette: INTEGER is 15

	-- Window Event constants
	Wm_null: INTEGER is 0
	Wm_create: INTEGER is 1
	Wm_destroy: INTEGER is 2
	Wm_move: INTEGER is 3
	Wm_size: INTEGER is 5
	Wm_activate: INTEGER is 6
	Wm_setfocus: INTEGER is 7
	Wm_killfocus: INTEGER is 8
	Wm_enable: INTEGER is 10 -- 0x000A
	Wm_paint: INTEGER is 15 -- 0x000F
	Wm_close: INTEGER is 16 -- 0x0010
	Wm_queryendsession: INTEGER is 17 -- 0x0011
	Wm_quit: INTEGER is 18 -- 0x0012
	Wm_queryopen: INTEGER is 19 -- 0x0013
	Wm_erasebkgnd: INTEGER is 20 -- 0x0014
	Wm_syscolorchange: INTEGER is 21 -- 0x0015
	Wm_endsession: INTEGER is 22 -- 0x0016
	Wm_showwindow: INTEGER is 24 -- 0x0018
	Wm_activateapp: INTEGER is 28 -- 0x001C
	Wm_fontchange: INTEGER is 29 -- 0x001D
	Wm_timechange: INTEGER is 30 -- 0x001E
	Wm_cancelmode: INTEGER is 31 -- 0x001F
	Wm_setcursor: INTEGER is 32 -- 0x0020
	Wm_mouseactivate: INTEGER is 33 -- 0x0021
	Wm_childactivate: INTEGER is 34 -- 0x0022
	Wm_painticon: INTEGER is 38 -- 0x0026
	Wm_iconerasebkgnd: INTEGER is 39 -- 0x0027
	Wm_sethotkey: INTEGER is 50 -- 0x0032
	Wm_gethotkey: INTEGER is 51 -- 0x0033
	Wm_compacting: INTEGER is 65 -- 0x0041
	Wm_windowposchanging: INTEGER is 70 -- 0x0046
	Wm_windowposchanged: INTEGER is 71 -- 0x0047
	Wm_copydata: INTEGER is 74 -- 0x004A
	Wm_keydown: INTEGER is 256 -- 0x0100
	Wm_keyup: INTEGER is 257 -- 0x0101
	Wm_char: INTEGER is 258 -- 0x0102
	Wm_deadchar: INTEGER is 259 -- 0x0103
	Wm_syschar: INTEGER is 262 -- 0x0106
	Wm_command: INTEGER is 273 -- 0x0111
	Wm_syscommand: INTEGER is 274 -- 0x0112
	Wm_timer: INTEGER is 275 -- 0x0113
	Wm_hscroll: INTEGER is 276 -- 0x0114
	Wm_vscroll: INTEGER is 277 -- 0x0115
	Wm_initmenu: INTEGER is 278 -- 0x0116
	Wm_initmenupopup: INTEGER is 279 -- 0x0117
	Wm_menuselect: INTEGER is 287-- 0x011F
	Wm_menuchar: INTEGER is 288 -- 0x0120
	Wm_enteridle: INTEGER is 289 -- 0x0121
	Wm_mousemove: INTEGER is 512 -- 0x0200
	Wm_lbuttondown: INTEGER is 513 -- 0x0201
	Wm_lbuttonup: INTEGER is 514 -- 0x0202
	Wm_lbuttondblclk: INTEGER is 515 -- 0x0203
	Wm_rbuttondown: INTEGER is 516 -- 0x0204
	Wm_rbuttonup: INTEGER is 517 -- 0x0205
	Wm_rbuttondblclk: INTEGER is 518 -- 0x0206
	Wm_mbuttondown: INTEGER is 519 -- 0x0207
	Wm_mbuttonup: INTEGER is 520 -- 0x0208
	Wm_mbuttondblclk: INTEGER is 521 -- 0x0209
	Wm_parentnotify: INTEGER is 528 -- 0x0210
	Wm_dropfiles: INTEGER is 563 -- 0x0233
	Wm_cut: INTEGER is 768 -- 0x0300
	Wm_copy: INTEGER is 769 -- 0x0301
	Wm_paste: INTEGER is 770 -- 0x0302
	Wm_clear: INTEGER is 771 -- 0x0303
	Wm_undo: INTEGER is 772 -- 0x0304
	Wm_querynewpalette: INTEGER is 783 -- 0x030F
	Wm_paletteischanging: INTEGER is 784 -- 0x0310
	Wm_palettechanged: INTEGER is 785 -- 0x0311
	Wm_hotkey: INTEGER is 786 -- 0x0312

	-- Paintstruct size for WM_PAINT
	Paintstruct_size: INTEGER is 64

	-- Extra pseudo-events
	Filo_scroll: INTEGER is 1280
	Filo_command: INTEGER is 1281

	-- Help
	Help_context: INTEGER is 1
	Help_quit: INTEGER is 2
	Help_index: INTEGER is 3 -- equals Help_contents
	Help_helponhelp: INTEGER is 4
	Help_setindex: INTEGER is 5
	Help_key: INTEGER is 257
	Help_command: INTEGER is 258

	-- Accelerator
	Fvirtkey: INTEGER is 1 -- 0x01 (TRUE?)
	Fnoinvert: INTEGER is 2 -- 0x02
	Fshift: INTEGER is 4 -- 0x04
	Fcontrol: INTEGER is 8 -- 0x08
	Falt: INTEGER is 16 -- 0x10

	-- Size constant
	Size_restored: INTEGER is 0
	Size_minimized: INTEGER is 1
	Size_maximized: INTEGER is 2
	Size_maxshow: INTEGER is 3
	Size_maxhide: INTEGER is 4

	-- Message box
	Mb_iconinformation: INTEGER is 64 -- 0x40
	Mb_iconexclamation: INTEGER is 48 -- 0x30
	Mb_iconquestion: INTEGER is 32 -- 0x20
	Mb_iconstop: INTEGER is 16 -- 0x10
	Mb_yesno: INTEGER is 4
	Mb_yesnocancel: INTEGER is 3
	Mb_ok: INTEGER is 0
	Mb_okcancel: INTEGER is 1
	Mb_retrycancel: INTEGER is 5
	Mb_abortretryignore: INTEGER is 2
	Idok: INTEGER is 1
	Idcancel: INTEGER is 2
	Idabort: INTEGER is 3
	Idretry: INTEGER is 4
	Idignore: INTEGER is 5
	Idyes: INTEGER is 6
	Idno: INTEGER is 7

	-- Clipboard
	Cf_text: INTEGER is 1
	Cf_bitmap: INTEGER is 2
	Cf_metafilepict: INTEGER is 3
	Cf_sylk: INTEGER is 4
	Cf_dif: INTEGER is 5
	Cf_tiff: INTEGER is 6
	Cf_oemtext: INTEGER is 7
	Cf_dib: INTEGER is 8
	Cf_palette: INTEGER is 9
	Cf_riff: INTEGER is 11
	Cf_wave: INTEGER is 12
	Cf_unicodetext: INTEGER is 13
	Cf_enhmetafile: INTEGER is 14

	-- Brushes
	Bs_solid: INTEGER is 0
	Bs_null: INTEGER is 1
	Bs_hatched: INTEGER is 2

	-- Brushes pattern
	Hs_horizontal: INTEGER is 0 -- -----
	Hs_vertical: INTEGER is 1 -- |||||
	Hs_fdiagonal: INTEGER is 2 -- \\\\\
	Hs_bdiagonal: INTEGER is 3 -- /////
	Hs_cross: INTEGER is 4 -- +++++
	Hs_diagcross: INTEGER is 5 -- xxxxx

	-- Pens
	Ps_cosmetic: INTEGER is 0
	Ps_geometric: INTEGER is 65536 -- 0x10000
	-- 
	Ps_solid: INTEGER is 0
	Ps_dash: INTEGER is 1 -- -----
	Ps_dot: INTEGER is 2 -- .....
	Ps_dashdot: INTEGER is 3 -- -.-.-
	Ps_dashdotdot: INTEGER is 4 -- -..-.
	Ps_null: INTEGER is 5
	Ps_insideframe: INTEGER is 6
	Ps_userstyle: INTEGER is 7 -- (not supported)
	Ps_alternate: INTEGER is 8 -- (only cosmetic)
	--
	Ps_endcap_round: INTEGER is 0
	Ps_endcap_square: INTEGER is 256 -- 0x100
	Ps_endcap_flat: INTEGER is 512 -- 0x200
	--
	Ps_join_round: INTEGER is 0
	Ps_join_bevel: INTEGER is 4096 -- 0x1000
	Ps_join_miter: INTEGER is 8192 -- 0x2000

	-- Page mapping mode
	Mm_text: INTEGER is 1
	Mm_lometric: INTEGER is 2
	Mm_himetric: INTEGER is 3
	Mm_loenglish: INTEGER is 4
	Mm_hienglish: INTEGER is 5
	Mm_twips: INTEGER is 6
	Mm_isotropic: INTEGER is 7
	Mm_anisotropic: INTEGER is 8

	-- Floodfile mode
	Floodfillborder: INTEGER is 0
	Floodfillsurface: INTEGER is 1
	
	-- Graphic background mode 
	Opaque: INTEGER is 2
	Transparent: INTEGER is 1

	-- ROP2 mode
	R2_black: INTEGER is 1
	R2_notmergepen: INTEGER is 2
	R2_masknotpen: INTEGER is 3
	R2_notcopypen: INTEGER is 4
	R2_maskpennot: INTEGER is 5
	R2_not: INTEGER is 6
	R2_xorpen: INTEGER is 7
	R2_notmaskpen: INTEGER is 8
	R2_maskpen: INTEGER is 9
	R2_notxorpen: INTEGER is 10
	R2_nop: INTEGER is 11
	R2_mergenotpen: INTEGER is 12
	R2_copypen: INTEGER is 13
	R2_mergepennot: INTEGER is 14
	R2_mergepen: INTEGER is 15
	R2_white: INTEGER is 16

	-- Text alignment
	Ta_left: INTEGER is 0
	Ta_center: INTEGER is 6
	Ta_right: INTEGER is 2
	Ta_top: INTEGER is 0
	Ta_baseline: INTEGER is 24
	Ta_bottom: INTEGER is 8

	-- LOGFONT structure size for enumeration
	Logfont_size: INTEGER is 60

	-- Font
	Fixed_pitch: INTEGER is 1
	Variable_pitch: INTEGER is 2
	Ff_roman: INTEGER is 16 -- 0x10
	Ff_swiss: INTEGER is 32 -- 0x20
	Ff_modern: INTEGER is 48 -- 0x30
	Ff_script: INTEGER is 64 -- 0x40
	Ff_decorative: INTEGER is 80 -- 0x50
	Ansi_charset: INTEGER is 0 -- also unicode (?)
	Default_charset: INTEGER is 1
	Oem_charset: INTEGER is 255
	Symbol_charset: INTEGER is 2

	-- Pseudo text metrics
	Ftm_overhang: INTEGER is 1
	Ftm_breakchar: INTEGER is 2
	Ftm_defaultchar: INTEGER is 3
	Ftm_firstchar: INTEGER is 4
	Ftm_lastchar: INTEGER is 5
	Ftm_avecharw: INTEGER is 6
	Ftm_maxcharw: INTEGER is 7
	Ftm_intleading: INTEGER is 8
	Ftm_extleading: INTEGER is 9
	Ftm_height: INTEGER is 10
	Ftm_weight: INTEGER is 11
	Ftm_ascent: INTEGER is 12
	Ftm_descent: INTEGER is 13
	Ftm_digaspx: INTEGER is 14
	Ftm_digaspy: INTEGER is 15
	Ftm_italic: INTEGER is 16
	Ftm_underline: INTEGER is 17
	Ftm_strikeout: INTEGER is 18
	Ftm_pitch: INTEGER is 19
	Ftm_family: INTEGER is 20
	Ftm_charset: INTEGER is 21
	Ftm_fixedpitch: INTEGER is 22
	Ftm_vector: INTEGER is 23
	Ftm_truetype: INTEGER is 24
	Ftm_device: INTEGER is 25

	-- Pseudo bad color for common dialog (win_std_color)
	Fcd_bad_color: INTEGER is 2130706432 -- 0x7F000000

	-- Device capabilities
	Driverversion: INTEGER is 0
	Technology: INTEGER is 2
	Dt_plotter: INTEGER is 0
	Dt_rasdisplay: INTEGER is 1
	Dt_rasprinter: INTEGER is 2 
	Dt_rascamera: INTEGER is 3
	Dt_charstream: INTEGER is 4
	Dt_metafile: INTEGER is 5
	Dt_dispfile: INTEGER is 6
	Horzsize: INTEGER is 4
	Vertsize: INTEGER is 6
	Horzres: INTEGER is 8
	Vertres: INTEGER is 10
	Logpixelsx: INTEGER is 88
	Logpixelsy: INTEGER is 90
	Bitspixel: INTEGER is 12
	Planes: INTEGER is 14
	Numbrushes: INTEGER is 16
	Numpens: INTEGER is 18
	Numfonts: INTEGER is 22 
	Numcolors: INTEGER is 24
	Aspectx: INTEGER is 40
	Aspecty: INTEGER is 42
	Aspectxy: INTEGER is 44
	Clipcaps: INTEGER is 36
	Sizepalette: INTEGER is 104
	Numreserved: INTEGER is 106
	Colorres: INTEGER is 108

	Rastercaps: INTEGER is 38
	Rc_palette: INTEGER is 256 -- 0x100
	Rc_bitblt: INTEGER is 1
	Rc_banding: INTEGER is 2
	Rc_scaling: INTEGER is 4
	Rc_bitmap64: INTEGER is 8
	Rc_di_bitmap: INTEGER is 128 -- 0x0080
	Rc_dibtodev: INTEGER is 512 -- 0x0200
	Rc_stretchblt: INTEGER is 2048 -- 0x0800
	Rc_floodfill: INTEGER is 65536 -- 0x1000
	Rc_stretchdib: INTEGER is 131072 -- 0x2000
	-- unsupported: Rc_*

	Curvecaps: INTEGER is 28
	Cc_circles: INTEGER is 1
	Cc_pie: INTEGER is 2
	Cc_chord: INTEGER is 4
	Cc_ellipses: INTEGER is 8
	-- unsupported: Cc_*
	Cc_roundrect: INTEGER is 256

	Linecaps: INTEGER is 30 
	Lc_none: INTEGER is 0
	Lc_polyline: INTEGER is 2
	-- unsupported: Lc_*

	Polygonalcaps: INTEGER is 32
	Pc_none: INTEGER is 0
	Pc_polygon: INTEGER is 1
	Pc_rectangle: INTEGER is 2
	Pc_windpolygon: INTEGER is 4
	-- unsupported: Pc_*

	Textcaps: INTEGER is 34
	Tc_op_character: INTEGER is 1
	Tc_op_stroke: INTEGER is 2
	Tc_cp_stroke: INTEGER is 4
	Tc_cr_90: INTEGER is 8
	Tc_cr_any: INTEGER is 16
	-- unsupported: Tc_*

	-- Registry
	Hkey_classes_root: INTEGER is 0
	Hkey_current_user: INTEGER is 1
	Hkey_local_machine: INTEGER is 2
	Hkey_users: INTEGER is 3
	Reg_none: INTEGER is 0
	Reg_sz: INTEGER is 1
	Reg_binary: INTEGER is 3
	Reg_dword: INTEGER is 4
	Reg_multi_sz: INTEGER is 7

	-- File
	Invalid_handle_value: INTEGER is -1 -- 0xFFFFFFFF
	Filetime_length: INTEGER is 8 -- sizeof (FILETIME)
	Max_path: INTEGER is 260

	Create_new: INTEGER is 1
	Create_always: INTEGER is 2
	Open_existing: INTEGER is 3
	Open_always: INTEGER is 4
	Truncate_existing: INTEGER is 5

	-- Synchronisation
	Infinite: INTEGER is -1 -- 0xFFFFFFFF

	-- File attributes
	File_attribute_readonly: INTEGER is 1 -- 0x1
	File_attribute_hidden: INTEGER is 2 -- 0x2
	File_attribute_system: INTEGER is 4 -- 0x4
	File_attribute_directory: INTEGER is 16 -- 0x10
	File_attribute_archive: INTEGER is 32 -- 0x20
	File_attribute_normal: INTEGER is 128 -- 0x80

	-- Time
	Filo_gmt: INTEGER is 0
	Filo_local: INTEGER is 1
	Filo_year: INTEGER is 10
	Filo_month: INTEGER is 11
	Filo_day: INTEGER is 12
	Filo_hour: INTEGER is 13
	Filo_minute: INTEGER is 14
	Filo_second: INTEGER is 15

	-- Standard dialog
	Separator_filter: CHARACTER is '|' -- File open/save dialog separator
	
end -- class WIN_CONST
