-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal, System
	description: "System file handle (as opposed to GUI WIN_OBJECT)"
	comment: "the invalid handle value is not like the one in invalid handle"
	interface: inheritance, internal

class WIN_HANDLE

inherit
	WIN_MEMORY
	
	WIN_API
	
	WIN_RUNTIME_FINAL


feature {WIN_API} -- Attribute
	
	handle: INTEGER

feature {NONE} -- Valid handle
	
	Invalid_handle_value: INTEGER is -1 -- 0xFFFFFFFF

	is_valid_handle: BOOLEAN is
		do
			Result := handle /= Invalid_handle_value
		ensure
			done: Result = (handle /= Invalid_handle_value)
		end

feature {NONE} -- Setting

	set_handle (nh: INTEGER) is
			-- Change/set handle.
		do
			handle := nh
		end

	reset_handle is
			-- Reset handle to invalid value.
		do
			handle := Invalid_handle_value
		ensure
			done: not is_valid_handle
		end

feature {NONE} -- Finalisation

	dispose is
			-- Close file handle.
		do
			if handle /= Invalid_handle_value then
				win_file_close (handle)
				handle := Invalid_handle_value
			end
		ensure then
			done: handle = Invalid_handle_value
		end

end -- class WIN_HANDLE

