-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics, Internal
	description: "(Internal) Win32 palette"
	interface: client, internal

class WIN_PALETTE

inherit
	WIN_GDI_OBJECT

creation
	make, make_handle

feature {NONE}
	
	Version_number: INTEGER is 768 -- 0x0300
	
	Version_offset: INTEGER is 1
	Size_offset: INTEGER is 3
	Entries_offset: INTEGER is 5

feature {NONE}
	
	make (pal: ARRAY[RGB_COLOR]) is
			-- Create Win32 palette.
		require
			valid: pal /= Void
		local
			struct: F_MEMORY
			i, cidx, palsize: INTEGER
		do
			finalisation_register
			palsize := pal.count
			
			-- create structure
			!!struct.make (palsize * 4 + 4)
			struct.set_unsigned_word (Version_offset, Version_number)
			struct.set_unsigned_word (Size_offset, pal.count)
			
			from
				i := 1
			variant
				palsize + 1 - i
			until
				i > palsize
			loop
				cidx := ((i-1) * 4) + Entries_offset
				struct.set_byte (cidx, pal.item (i).red)
				cidx := cidx + 1
				struct.set_byte (cidx, pal.item (i).green)
				cidx := cidx + 1
				struct.set_byte (cidx, pal.item (i).blue)
				-- flags left to zero

				i := i + 1
			end
		
			-- create object
			set_handle (wrt.win_gdi_palette (struct.to_windows))
		end

	make_handle (h: INTEGER) is
		require
			valid: h /= 0
		do
			finalisation_register
			set_handle (h)
		end
	
end -- class WIN_PALETTE
