-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics, Internal
	description: "Internal pen (for use with graphic devices)"
	interface: client, internal

class WIN_PEN

inherit
	WIN_GDI_OBJECT

creation {WIN_API}
	make_null, make_white, make_black,
	make_traditional,
	make_cosmetic,
	make_geometric

feature {NONE} -- Creation

	make_null is
		do
			finalisation_register
			set_handle (wrt.win_gdi_stock (wrt.Null_pen))
		end

	make_white is
		do
			finalisation_register
			set_handle (wrt.win_gdi_stock (wrt.White_pen))
		end

	make_black is
		do
			finalisation_register
			set_handle (wrt.win_gdi_stock (wrt.Black_pen))
		end

	make_traditional (width: INTEGER; style: INTEGER; colour: COLOR) is
			-- Make traditional ( la Win16) pens. They are like cosmetic 
			-- pens but may be of possibly variable width.
		do
			finalisation_register
			set_handle (wrt.win_gdi_pen (style, width, colour.to_windows))
		end

	make_cosmetic (style: INTEGER; colour: COLOR) is
			-- Cosmetic pen (quick)
		do
			finalisation_register
			set_handle (wrt.win_gdi_expen (wrt.Ps_cosmetic, 1, style, 0, 0,
					colour.to_windows, wrt.Bs_solid, 0))
		end

	make_geometric (width: INTEGER; style, endstyle, joinstyle: INTEGER; brush: BRUSH) is
			-- Geometric (scalable) pen
		local
			clr: COLOR
		do
			finalisation_register
			clr := brush.to_color
			set_handle (wrt.win_gdi_expen (wrt.Ps_geometric, width, style, endstyle, joinstyle,
					clr.to_windows, brush.to_brush_style, brush.to_brush_hatch))
		end

end -- class WIN_PEN

