-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal
	description: "(Internal) convert list of string to string with cr/lf and back"
	interface: mixin, internal

class WIN_STRING_LIST

feature

	list_to_string (lst: P_LIST[STRING]): STRING is
			-- Convert list of lines (strings) to a single 
			-- string with cr/lf separated lines.
		local
			it: P_ITERATOR[STRING]
		do
			!!Result.make (lst.count * 50)
			from
				it := lst.iterator
				it.first
			variant
				it.forward_variant
			until
				it.outside
			loop
				if it.item /= Void then
					Result.append_string (it.item)
				end
				it.forth
				if not it.outside then -- not last
					Result.append_string ("%R%N")
				end
			end
		end
	
	string_to_list (instr: STRING): P_LIST[STRING] is
			-- Convert a string with lines separated by cr/lf to 
			-- a list of lines.
		local
			cchar: CHARACTER
			line: STRING
			i: INTEGER
		do
			!P_LINKED_LIST[STRING]!Result.make

			from
				i := 1
				!!line.make (0)
				Result.add (line)
			variant
				instr.count - i + 1
			until
				i > instr.count
			loop
				cchar := instr.item (i)
				if cchar = '%N' then
					-- remove trailing %r
					if line.count > 0 and then line.item (line.count) = '%R' then
						line.remove (line.count)
					end
				
					-- prepare new current line
					!!line.make (0)
					Result.add (line)
				else
					line.append_character (cchar)
				end

				-- forth
				i := i + 1
			end -- loop
		end

end -- class WIN_STRING_LIST
