-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

indexing
	cluster: Pylon, Test
	description: "Testing date & time"
	interface: client

class TEST_TIME

inherit
	TESTER
		end

creation
	execute

feature {NONE}
	
	date : P_DATE
	time : P_TIME
	dt : P_DATE_TIME

feature
	
	execute is
		do
			!!date
			date.set(1887,7,26)
			print_date
			test_textobject(date)
			
			!!time
			time.set(23,30,59)
			print_time
			test_textobject(time)

			!!dt.make
			dt.date.copy(date)
			dt.time.copy(time)
			print_dt
			test_textobject(dt)
		end

	print_date is
		do
			put_title("date: ")
			
			put_string(date.out)
			put_string(" ")
			put_string(date.to_iso_long)
			put_string(" ")
			put_string(date.to_rfc)
			put_string(" ")
			put_string(date.to_european)
			put_string(" ")
			put_string(date.to_american)
			put_nl

			put_string("day of week: ")
			put_string(date.day_of_week.out)
			put_string(", day of year: ")
			put_string(date.day_of_year.out)
			put_string(", leap: ")
			put_string(date.is_leap_year.out)
			put_nl
		end

	print_time is
		do
			put_string("time: ")
			put_string(time.out)
			put_string(" ")
			put_string(time.to_rfc)
			put_nl
		end

	print_dt is
		do
			put_string("date & time: ")
			put_string(dt.out)
			put_string(" * ")
			put_string(dt.to_iso_long)
			put_string(" * ")
			put_string(dt.to_rfc)
			put_nl
		end

	test_textobject(t : P_TEXT_OBJECT) is
		do
			put_string("textobj: ")
			put_string(t.to_string)
			put_nl
		end

end
