-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Bubble - application window"
	interface: client

class APP

inherit
	APPLICATION
		redefine
			when_created, when_closed
		end

creation
	make

feature {NONE}
	
	draw: BUBBLE_DRAW

feature {PUBLIC_NONE}

	when_created is
		local
			ico: ICON
			toolb: BUBBLE_TOOLBAR
			stack: HORIZONTAL_STACK_WINDOW
		do
			!!ico.make_resource ("AppIcon")
			set_icon (ico)

			!! stack.make (Current)

				!!toolb.make (stack)
				toolb.fixed_width

			stack.set_first (toolb)

				!!draw.make (stack, toolb)
				draw.name.apply

			stack.set_variable (draw)
			stack.size_follows_parent

			init_menu
		end

	when_closed is
		local
			quit: CMD_FILE_QUIT
		do
			!!quit.make (draw)
			quit.question
			set_close_ready (quit.is_ok)
		end

feature {NONE}
	
	init_menu is
		local
			menubar: MENU_BAR
			popup: POPUP_MENU
			item: MENU_ITEM
			cmd: GUI_COMMAND
		do
			!!menubar.make (Current)
			
			!!popup.make (Current)
			popup.set_name ("&File")

				!!item.make ("&New")
				item.set_help ("Create new drawing")
				!CMD_FILE_NEW!cmd.make (draw)
				item.set_command (cmd)
				popup.add_item (item)

				popup.add_separator

				!!item.make ("&Open...")
				item.set_help ("Open drawing file.")
				!CMD_FILE_LOAD!cmd.make (draw)
				item.set_command (cmd)
				popup.add_item (item)
				
				!!item.make ("&Save")
				item.set_help ("Save current drawing file.")
				!CMD_FILE_SAVE!cmd.make (draw)
				item.set_command (cmd)
				popup.add_item (item)

				!!item.make ("Save &as...")
				item.set_help ("Save drawing file using new name.")
				!CMD_FILE_SAVE_AS!cmd.make (draw)
				item.set_command (cmd)
				popup.add_item (item)
				
				popup.add_separator
				
				-- "Save as &EPS"...
				-- "Save as &metafile"...
				-- popup.add_separator

				!!item.make ("Q&uit")
				item.set_help ("Exit program.")
				!CMD_FILE_QUIT!cmd.make (draw)
				item.set_command (cmd)
				popup.add_item (item)
			
			menubar.add_popup (popup)

			menubar.add_popup (draw.edit_menu)
			menubar.add_popup (draw.tool_menu)
			menubar.add_popup (draw.zoom_menu)

			!!popup.make (Current)
			popup.set_name ("&Help")

				!!item.make ("&About")
				item.set_help ("Copyright information.")
				!CMD_HELP_ABOUT!cmd.make (Current)
				item.set_command (cmd)
				popup.add_item (item)

			menubar.add_popup (popup)

			menubar.attach
		end
end
