-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Moving an arrow"
	interface: client

class ARROW_MOVE

inherit 
	BUBBLE_SHADOW
		end

creation
	make_start, make_final

feature {NONE} -- Creation

	make_start (start_point: POINT) is
			-- Create from start point.
		require
			ok: start_point /= Void
		do
			is_start := true
			!!start.make
			start.copy (start_point)
			!!final.make
		end

	make_final (final_point: POINT) is
			-- Create from final point.
		require
			ok: final_point /= Void
		do
			is_start := false
			!!start.make
			start.copy (final_point)
			!!final.make
		end

feature -- Attributes
	
	is_start: BOOLEAN
	start, final: POINT

feature
	
	set_anchor (pt: POINT) is
			-- Change anchor point (mouse drag usually).
		do
			final.copy (pt)
		end
	
end

