-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Properties dialog for arrow"
	interface: client

class ARROW_PROPERTIES

inherit
	MODELESS_DIALOG
		end

creation
	make

feature -- Set client

	set_object (obj: ARROW) is
			-- Set associated object.
		require
			ok: obj /= Void
		do
			arrow := obj
			if arrow.is_client then
				client.check_mark
			else
				inheritance.check_mark
			end
		ensure
			keep_reference: arrow = obj
		end

	set_draw (dw: BUBBLE_DRAW) is
			-- Associated draw window.
		require
			ok: dw /= Void
		do
			draw := dw
		ensure
			keep_reference: draw = dw
		end

feature {NONE}
	
	arrow: ARROW
	draw: BUBBLE_DRAW

	inheritance: HEAD_RADIO_BUTTON
	client: RADIO_BUTTON
	
feature {PUBLIC_NONE}
	
	when_prepared is
		local
			group: STD_GROUP_BOX
			ok, cancel: PUSH_BUTTON
		do
			set_text ("Relation properties")

			!!group.make (Current)
			group.set_label ("Relation type")

			!STD_HEAD_RADIO!inheritance.make (Current)
			inheritance.set_label ("&Inheritance")
			inheritance.adapt_width
			group.arrange_first (inheritance)

			!STD_RADIO_BUTTON!client.make (Current)
			client.set_label ("&Client");
			client.set_leader (inheritance)
			client.place_just_under (inheritance)
			client.adapt_width
			group.arrange (client)
			
			!OK_BUTTON!ok.make (Current)
			ok.set_label ("&OK")
			ok.place_right (group)
			set_ok_push_button (ok)

			!CANCEL_BUTTON!cancel.make (Current)
			cancel.set_label ("&Cancel")
			cancel.place_under (ok)
			set_cancel_push_button (cancel)

			arrange
		end

	when_finished is
		do
		end

	when_applied is
		do
			arrow.set_client (client.is_checked)
			draw.paint_logical_rectangle (arrow.bounding_box)
		end

end -- class ARROW_PROPERTIES
