-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Move rectangular object"
	interface: client

class BOX_MOVE inherit BOX_SHADOW end

creation 
	make

feature {NONE} -- Creation
	
	make (original_position: RECTANGLE; offset_x, offset_y: INTEGER) is
			-- Create.
		require
			ok_pos: original_position /= Void
			positive_offset: offset_x >= 0 and offset_y >= 0
		do
			!!position.make
			position.copy (original_position)
			x_offset := offset_x
			y_offset := offset_y
		ensure
			done_pos: position.is_equal (original_position)
			done_offs: offset_x = x_offset and y_offset = offset_y
		end

feature {NONE} -- Private attributes

	x_offset, y_offset: INTEGER

feature
	
	position: RECTANGLE
		-- Shadow position.

feature

	set_anchor (anchor_pt: POINT) is
		local
			pt: POINT
		do
			!!pt.make
			pt.set_x (anchor_pt.x - x_offset)
			pt.set_y (anchor_pt.y - y_offset)
			position.translate_lower (pt)
		end
	
end
