-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Edit|Properties menu command"
	interface: client

class CMD_EDIT_PROPERTIES inherit GUI_COMMAND end

creation
	make

feature {NONE}
	
	make (p: BUBBLE_DRAW) is
		require
			ok: p /= Void
		do
			parent := p
		ensure
			keep_reference: parent = p
		end

feature {NONE}
	
	parent: BUBBLE_DRAW
	current_dialog: MODELESS_DIALOG

feature
	
	execute is
		local
			msg: MESSAGE_BOX
		do
			if current_dialog /= Void and then current_dialog.is_valid then
				--? sensible if other object currently selected?
				current_dialog.activate
			else
				current_dialog := Void
				if parent.selected /= Void then
					current_dialog := parent.selected.properties (parent)
				end

				if current_dialog = Void then
					!!msg.make (parent.overlapped_parent)
					msg.set_title ("No properties")
					msg.set_text ("No object is currently selected or it has no editable properties.")
					msg.execute
				end
			end
		end

end
