-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "File|Quit command"
	interface: client

class CMD_FILE_QUIT inherit GUI_COMMAND end

creation
	make

feature {NONE}
	
	make (win: BUBBLE_DRAW) is
		require
			ok: win /= Void
		do
			draw := win
		ensure
			keep_reference: draw = win
		end

feature {NONE}
	
	draw: BUBBLE_DRAW
	
feature

	execute is
			-- Command.
		do
			question
			if is_ok then
				draw.overlapped_parent.destroy
			end
		end

	question is
			-- Ready to quit?
		local
			msg: MESSAGE_BOX
		do
			if draw.drw.is_blank then
				is_ok := true
			else
				!!msg.make (draw.overlapped_parent)
				msg.set_icon_question
				msg.set_title ("Quit?")
				msg.set_text ("Do you really want to exit program?")
				msg.set_buttons_yes_no
				msg.execute
				is_ok := msg.is_yes
			end
		end

	is_ok: BOOLEAN;
			-- Answer to question.
	
end
