-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Tool|Bubble tool change command"
	interface: client

class CMD_TOOL_BUBBLE inherit CMD_TOOL end

creation make
	
feature {NONE}
	
	icon_name: STRING is do Result := "ToolBubble" end

	get_box: BOX is
		do
			!BUBBLE!Result.make
		end

feature
	
	execute is
		do
			-- unselect and reset default mouse manager
			draw.unselect
			draw.set_left_mouse_manager (Void)
			apply
		end

	click (pt: POINT) is
		local
			bob: BOX
		do
			-- put object
			bob := get_box
			
			-- add to drawing
			draw.drw.add_object (bob)

			-- position
			draw.device.prepare
			bob.set_center (draw.device.device_to_logical (pt))
			draw.device.release

			-- update display
			draw.paint_logical_rectangle (bob.position)
		end

	right_click (pt: POINT) is
		do
			-- back to edit mode
			draw.tool_edit.execute
		end

end
