-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	description: "Generic demonstration child window"

deferred class DEMO_CHILD

inherit
	CHILD_WINDOW
		redefine
			when_mouse_rclicked
		end

feature {NONE} -- Creation

	make (p: WINDOW) is
		do
			make_child (p)
			make_popup (overlapped_parent)
		end

feature {NONE}
	
	overlapped_parent: OVERLAPPED_WINDOW is
			-- Find overlapped_window parent.
		local
			maxgen: INTEGER -- maximum recursion
			w: WINDOW
		do
			w := Current

			from 
				maxgen := 5 
			variant 
				maxgen 
			until 
				Result /= Void 
			loop
				check no_end: w /= Void end
				w := w.parent
				Result ?= w
				maxgen := maxgen - 1
			end
		ensure
			found: Result /= Void
		end
feature
	
	popup: POPUP_MENU;
			-- Menu associated with this window.
	
	make_popup (p: OVERLAPPED_WINDOW) is
			-- Initialise 'popup'.
		deferred
		ensure
			done: popup /= Void
		end

feature {PUBLIC_NONE}
	
	when_mouse_rclicked (p: POINT) is
			-- Right mouse button clicked: context popup menu.
		local
			newp: POINT
		do
			-- convert from child to parent coordinates,
			-- as popup associated to overlapped window.
			!!newp.make
			newp.set_x (p.x + size.lower.x)
			newp.set_y (p.y + size.lower.y)

			popup.pop_up (newp)
		end
	
end
