-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

deferred class GRAPHICS_COMMAND inherit GUI_COMMAND end

feature {NONE} -- Creation

	make (par: GRAPHICS) is
			-- Initialise.
		require
			ok: par /= Void
		do
			parent := par
		ensure
			keep_reference: parent = par
		end

feature {NONE}
	
	parent: GRAPHICS

feature

	execute is
			-- Event.
		do
			parent.set_figure (Current)
		end

	figure (pt: POINT; size: INTEGER): DRAWABLE is
			-- Produce drawable object.
		require
			ok: pt /= Void
			valid_size: size > 0
		deferred
		ensure
			done: Result /= Void
		end

end
