-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 
-- Utility to generate Fenestra Functor,
-- Public domain FA 1996-04-26

class MKFUNCTOR inherit ARGUMENTS creation make

feature

	make is
			-- Create.
		do
			if argument_count /= 3 then
				io.put_string ( "usage: mkfunctor <functor-class> <target-class> <function>")
				io.put_new_line
			else
				output_class (argument (1), argument (2), argument (3))
			end
		end

feature
	
	output_class (class_name, target_class, target_function: STRING) is
			-- Actual class to stdio.
		require
			ok: class_name /= Void and target_class /= Void and target_function /= Void
		do
			class_name.to_upper
			target_class.to_upper
			target_function.to_lower

			io.put_string ("-- GUI functor (automatically generated)") io.put_new_line
			io.put_new_line
			io.put_string ("class ") io.put_string (class_name) io.put_new_line
			io.put_string ("inherit BOOMERANG_COMMAND[") 
				io.put_string (target_class) io.put_string ("]") io.put_new_line
			io.put_string ("creation make") io.put_new_line
			io.put_string ("feature execute is do parent.") 
				io.put_string (target_function) io.put_string (" end") io.put_new_line
			io.put_string ("end") io.put_new_line
		end

end -- class MKFUNCTOR
