-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, System
	description: "Multimedia MCI command string interface"
	interface: client

class F_MULTIMEDIA

inherit
	WIN_API
		end

feature -- Command
	
	send_command (com: STRING) is
			-- Send MCI (Media Control Interface) command string.
		require
			ok: com /= Void
		local
			errcode: INTEGER
		do
			last_result := true
			!!last_error.make (0)

			errcode := wrt.win_mci_send (wrt.ew_string (com).to_c)
			if errcode /= 0 then
				last_result := false
				wrt.win_mci_error (errcode)
				last_error := wrt.win_laststring
			end
		end
	
	last_result: BOOLEAN;
			-- Was last command succesful (true if so)?

	last_error: STRING;
			-- Last error message (if last_result = false).

end -- class F_MULTIMEDIA
