-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, System
	description: "Random-access file"
	interface: client

class F_RANDOM_FILE

inherit
	F_FILE
		redefine
			random_access
		end
	F_FINITE_STREAM
		end

creation
	make

feature {NONE}
	
	random_access: BOOLEAN is
		do
			Result := true
		end

feature -- Position
	
	position: INTEGER is
			-- Current position in the stream.
		do
			Result := wrt.win_file_ptr (handle)
			if Result < 0 then
				has_error := true
				Result := 1
			end
		end

	set_position (idx: INTEGER) is
			-- Set current position in stream.
		do
			write_flush
			has_error := not wrt.win_file_setptr (handle, idx-1)
			reset_buffer
		end

	size: INTEGER is
			-- Current size of stream in bytes.
		do
			Result := wrt.win_file_size (handle)
			if Result < 0 then
				has_error := true
				Result := 1
			end
		end

end -- class F_RANDOM_FILE
