-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, System
	description: "Network stream (TCP/IP socket)"
	comment: "creation procedure (make) is provided for descendants"
	interface: inheritance

deferred class F_SOCKET

inherit
	F_ASYNCH_IO

	WIN_TCP_BASE

feature {NONE} -- Address attributes
	
	ip1, ip2, ip3, ip4, port: INTEGER

feature -- Setup
	
	set_address (ip_address: IP_ADDRESS) is
		require
			closed: not is_alive
		do
			ip1 := ip_address.b1
			ip2 := ip_address.b2
			ip3 := ip_address.b3
			ip4 := ip_address.b4
		end

	set_port (port_id: INTEGER) is
			-- Set TCP port
		require
			ok: port_id >= 0
			closed: not is_alive
		do
			port := port_id
		end

	connect is
			-- Open TCP connection.
		do
			is_connect_readable := false
			is_connect_writable := false

			init_tcp
			set_handle (wrt.win_tcp_connect (ip1, ip2, ip3, ip4, port))
			is_alive := is_valid_handle

			if is_alive then
				is_connect_readable := true
				is_connect_writable := true
			end

			init_connect
		end

feature {WIN_API} -- Internal opening by server.
	
	connect_server (accept_handle: INTEGER) is
			-- Set socket from new connection created by F_SERVER.
		do
			is_connect_readable := false
			is_connect_writable := false
			
			set_handle (accept_handle)
			is_alive := is_valid_handle
			
			if is_alive then
				is_connect_readable := true
				is_connect_writable := true
			end
			init_connect
		ensure
			done: -- is_alive set
		end

end -- class F_SOCKET
