-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, System
	description: "Miscellaneous system services"
	interface: client, mixin

class F_SYSTEM

inherit
	WIN_API
		end

feature

	sleep (milliseconds: INTEGER) is
			-- Do nothing for `milliseconds'. The current process will 
			-- then be idle for that time.
		require
			valid: milliseconds >= 0
		do
			if milliseconds > 0 then
				wrt.win_sleep (milliseconds)
			end
		end

	execute (command: STRING) is
			-- Create a new process.
		require
			valid: command /= Void
		local
			res: BOOLEAN
		do
			res := wrt.win_execute (wrt.ew_string (command).to_c)
		end

	process_id: INTEGER is
			-- ID of current process (maybe used as unique identifier).
		do
			Result := wrt.win_getpid
		end

	output_debug_string (str: STRING) is
			-- Output debug string to a debugger or a monitor program 
			-- listening to debug output.
		require
			valid: str /= Void
		do
			wrt.win_debugout (wrt.ew_string (str).to_c)
		end

	beep is
			-- System beep.
		require
			hardware: -- machine.has_soundboard or else machine.has_speaker 
		do
			wrt.win_beep (0)
		end

	string_from_resource (id: INTEGER): STRING is
			-- Get string from resource.
		require
			valid_id: -- has_resource_id (or else Result.empty)
		do
			wrt.win_rsrcstring (id)
			Result := wrt.win_laststring
		ensure
			done: Result /= Void
			is_copy: -- New string
		end
	
end -- class F_SYSTEM
