-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Child window whose background is drawn by the system"
	interface: inheritance

class CHILD_WINDOW_COLOR

inherit
	CHILD_WINDOW
		end

creation
	make_child_color, make_child_scroll_color, 
	make_child_vertical_scroll_color, 
	make_child_horizontal_scroll_color

feature {CREATION_NONE} -- Creation

	make_child_color (par: like parent; color: COLOR) is
			-- Create a child window.
		do
			-- do it
			make_internal_color (par, color, false, false)
		end

	make_child_horizontal_scroll_color (par: like parent; color: COLOR) is
			-- Make a child window with a horizontal scrollbar.
		do
			make_internal_color (par, color, true, false)
		end

	make_child_vertical_scroll_color (par: like parent; color: COLOR) is
			-- Make a child window with a vertical scrollbar.
		do
			make_internal_color (par, color, false, true)
		end
	
	make_child_scroll_color (par: like parent; color: COLOR) is
			-- Make a child window with both vertical and horizontal scrollbar.
		do
			make_internal_color (par, color, true, true)
		end

feature {NONE}
	
	make_internal_color (par: like parent ; color: COLOR; hslid, vslid: BOOLEAN) is
		do
			-- create
			parent := par
			!!wo.make_handle (wrt.win_create_clrchild (parent.handle, color.to_windows, free_cursor, hslid, vslid))
			has_horizontal_scrollbar := hslid
			has_vertical_scrollbar := vslid
			register
		end

end -- class CHILD_WINDOW_COLOR
