-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Child window with customisable cursor"
	interface: inheritance

class CHILD_WINDOW_CURSOR

inherit
	CHILD_WINDOW
		redefine
			when_mousemoved, free_cursor
		select
			when_mousemoved
		end
	CHILD_WINDOW
		rename 
			when_mousemoved as old_when_moved
		export 
			{NONE} all 
		undefine
			free_cursor
		end

feature {NONE} -- Status

	cursor: MOUSE_CURSOR
	free_cursor: BOOLEAN is do Result := true end

feature -- Cursor

	set_cursor (mc: MOUSE_CURSOR) is
			-- Change this window's cursor.
		require
			ok: mc /= Void and mc.is_valid
		do
			cursor := mc
		ensure
			keep_reference: cursor = mc
		end

feature {NONE} -- (Internal) event(s)
	
	when_mousemoved (p: POINT) is
			-- (Internal) mouse move.
		do
			if cursor /= Void then
				cursor.apply
			end
			old_when_moved (p)
		end
	
end -- class CHILD_WINDOW_CURSOR
