-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Clipboard
	description: "Clipboard access for graphic metafiles"
	interface: client

class CLIPBOARD_METAFILE

inherit
	CLIPBOARD
		end

creation
	make

feature {NONE}
	
	metafile: METAFILE_DEVICE
	last_handle: INTEGER

feature
	
	has_data: BOOLEAN is
		do
			Result := wrt.win_clip_has (wrt.Cf_enhmetafile)
		end

feature 
	
	set_metafile (mf: METAFILE_DEVICE) is
			-- Set a metafile for copying to the clipboard.
		require
			ready: mf.is_ready
			stays_ready: -- mf.is_ready when put too.
		do
			has_result := false
			metafile := mf
		ensure
			keep_reference: metafile = mf
			copy_means_release: -- put implies not mf.is_ready
		end

	last_metafile: DRAWABLE_CLIP_METAFILE is
			-- Last retrieved drawable metafile.
		require
			possible: has_result
		do
			!!Result.make_handle (last_handle)
		end

feature {NONE}
	
	internal_put is
		do
			check has_metafile: metafile /= Void end
			if metafile.is_ready then
				metafile.get_metafile
				if metafile.last_metafile /= 0 then
					wrt.win_clip_copy (wrt.Cf_enhmetafile, metafile.last_metafile)
				end
				metafile.delete_metafile
			end
		end

	internal_get is
		do
			last_handle := wrt.win_clip_paste (wrt.Cf_enhmetafile)
			has_result := (last_handle /= 0)
		end
		
end -- class CLIPBOARD_METAFILE
