-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Clipboard
	description: "Editable object (can be cut/copy/pasted to clipboard)"
	interface: abstract, inheritance
		
deferred class CLIPBOARD_OBJECT

feature

	has_selection: BOOLEAN is
			-- Is there a current selection?
		deferred
		end

	cut_selection is
			-- Cut the current selection to the clipboard.
		require
			has_selection: has_selection
		do
			copy_selection
			delete_selection
		end

	copy_selection is
			-- Copy the current selection to the clipboard.
		require
			has_selection: has_selection
		deferred
		end

	paste_clipboard is
			-- Paste current clipboard to object.
		deferred
		ensure
			has_selection: has_selection
		end

	delete_selection is
			-- Delete current selection.
		require
			has_selection: has_selection
		deferred
		end

	select_all is
			-- Select everything.
		deferred
		end

end -- class CLIPBOARD_OBJECT
