-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Clipboard
	description: "Clipboard for colour palette"
	interface: client

class CLIPBOARD_PALETTE

inherit
	CLIPBOARD
		end

creation
	make

feature -- Status

	has_data: BOOLEAN is
			-- Is palette available?
		do
			Result := wrt.win_clip_has (wrt.Cf_palette)
		end

feature -- Data

	set_palette (pal: PALETTE) is
			-- Set text to be copied to the clipboard.
		require
			valid: pal /= Void
		do
			has_result := false
			palette := pal
		ensure
			keep_reference: palette = pal
		end

feature {NONE}
	
	palette: PALETTE
	last_handle: INTEGER

feature -- Result

	last_palette: PALETTE is
			-- Last retrieved palette.
		require
			possible: has_result
		do
			!WIN_CLIP_PALETTE!Result.make_handle (last_handle)
		ensure
			is_copy: Result /= Void
		end

feature {NONE}
	
	internal_put is
		local
			winpal: WIN_PALETTE
		do
			winpal := palette.to_windows
			wrt.win_clip_copy (wrt.Cf_palette, winpal.handle)
			winpal.reset_handle
		end

	internal_get is
		do
			last_handle := wrt.win_clip_paste (wrt.Cf_palette)
			has_result := (last_handle /= 0)
		end

end -- class CLIPBOARD_PALETTE
