-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Clipboard
	description: "Standard colour-selection dialog box"
	interface: client

class COLOR_DIALOG

inherit
	STANDARD_DIALOG
		end

creation
	make

feature {CREATION_NONE} -- Creation
	
	make (p: OVERLAPPED_WINDOW) is
			-- Create.
		do
			parent := p
			win_color := 0 -- black
		end

feature -- Value
	
	set_color (clr: COLOR) is
			-- Default colour.
		require
			valid: clr /= Void
		do
			win_color := clr.to_windows
		end
	
	color: COLOR is
			-- Selected colour.
		require
			done: has_selection
		do
			!STANDARD_COLOR!Result.make (win_color)
		ensure
			is_copy: Result /= Void
		end

feature -- Execution

	has_selection: BOOLEAN
			-- Has the value been successfully selected?
		
	execute is
			-- Display dialog box.
		do
			win_color := wrt.win_std_color (parent.handle, win_color)
			if win_color = wrt.Fcd_bad_color then
				win_color := 0
				has_selection := false
			else
				has_selection := true
			end
		end
	
feature {NONE}
	
	parent: WINDOW
	win_color: INTEGER

invariant
	good_parent: parent /= Void

end -- class COLOR_DIALOG
