-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Menu
	description: "Menu-item associated with a dialog box"
	interface: client
	
class DIALOG_COMMAND

inherit 
	GUI_COMMAND 
		end

creation 
	make

feature {CREATION_NONE}
	
	make (dlg: MODELESS_DIALOG) is
			-- Create and associate with a valid dialog box.
		require
			valid: dlg /= Void and then dlg.is_valid
		do
			dialog := dlg
		ensure
			keep_reference: dialog = dlg
		end

feature {PUBLIC_NONE}
	
	execute is
		do
			if not dialog.is_visible then
				dialog.show
			else
				dialog.hide
			end
		end
	
feature {NONE}
	
	dialog: MODELESS_DIALOG
	
end -- class DIALOG_COMMAND
