-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Menu
	description: "Leading menu item for radio button style menu items"
	interface: client

class HEAD_MENU_ITEM

inherit
	MENU_ITEM
		redefine make
		select make
		end
	MENU_ITEM
		rename make as old_make
		export {NONE} old_make
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (s: STRING) is
			-- Create head menu item.
		do
			!!itemlist.make
			add_item (Current)
			
			old_make (s)
			
			leader := Current
		end

feature {NONE}
	
	itemlist: P_LINKED_LIST[MENU_ITEM]

feature {NONE}
	
	update_mark is
			-- Update mark after list has been updaten if no item marked.
		local
			it: P_ITERATOR[MENU_ITEM]
			found: BOOLEAN
		do
			-- if item alive, search marked item and marks us if none
			if is_valid then
				-- search marked item
				from
					it := itemlist.iterator
					it.first
				variant it.forward_variant until it.outside loop
					if it.item.is_valid and then it.item.is_checked then 
						it.stop
						found := true
					else
						it.forth
					end
				end

				if not found then -- mark us
					check_mark
				end
			end
		end
		
feature {MENU_ITEM}
	
	add_item (mi: MENU_ITEM) is
			-- Add associated item to this leader's list.
		require
			valid: mi /= Void
		do
			itemlist.add (mi)
			update_mark
		end

	remove_item (mi: MENU_ITEM) is
			-- Remove item associated with this leader.
		require
			valid: mi /= Void
			own: -- mi.is_ours
		do
			itemlist.equality_search (mi)
			check itemlist.found end
			itemlist.remove
			update_mark
		end

	uncheck_all is
			-- Remove check mark on all associated item.
		local
			it: P_ITERATOR[MENU_ITEM]
		do
			from
				it := itemlist.iterator
				it.first
			variant
				it.forward_variant
			until
				it.outside
			loop
				if it.item.is_valid and then it.item.is_checked then
					it.item.uncheck_mark
				end
				it.forth
			end
		end

end -- class HEAD_MENU_ITEM
