-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "WinHelp calls"
	interface: abstract

deferred class HELP_COMMAND

inherit
	GUI_COMMAND
		redefine
			execute
		end
	WIN_API
		end

feature {CREATION_NONE} -- Creation

	make (par: WINDOW) is
			-- Create this object.
		require
			valid_window: par /= Void
		do
			parent := par
			parent.set_help_open
			!!helpfile.make (0)
		ensure
			keep_reference: par = parent
		end

feature {NONE}
	
	parent: WINDOW
	helpfile: STRING
		
feature -- Status

	set_helpfile (str: STRING) is
			-- Set the current helpfile.
		require
			valid_str: str /= Void
			valid_help: -- `str' must be path to valid helpfile.
		do
			helpfile.copy (str)
		end

feature -- Command

	last_command_success: BOOLEAN
			-- Was the last request succesful?

	execute is
			-- Execute help command
		deferred
		ensure then
			done: -- `last_command_success' set.
		end

invariant
	valid_parent: parent /= Void
	valid_help: helpfile /= Void

end -- class HELP_COMMAND
