-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Help
	description: "Hold a context help string"
	interface: inheritance

class HELP_STRING

creation
	-- effectively deferred

feature
	
	help: STRING

	set_help, make (s: STRING) is
			-- Set help string.
		require
			valid_string: s /= Void
		do
			help := s
			when_changed
		ensure
			keep_reference: help = s
		end

	copy_help_to (other: HELP_STRING) is
			-- Copy from `other'.
		require
			valid: other /= Void
		do
			other.set_help (help)
		ensure
			keep_reference: other.help = help
		end

feature {PUBLIC_NONE}
	
	when_changed is
			-- Help string has been changed.
		do
		end

invariant
	valid_help: help /= Void

end -- class HELP_STRING
