-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Keyboard
	description: "Misc. keyboard routines (mix-in class)"
	interface: mixin, client

class KEYBOARD_ROUTINES

feature -- Functions
	
	ascii_to_vkey (alpha: CHARACTER): VIRTUAL_KEY is
			-- Produce virtual key corresponding to alpha character.
		require
			alpha: is_alpha (alpha)
		do
			!!Result.make

			inspect alpha
			when 'a','A' then Result.set_a
			when 'b','B' then Result.set_b
			when 'c','C' then Result.set_c
			when 'd','D' then Result.set_d
			when 'e','E' then Result.set_e
			when 'f','F' then Result.set_f
			when 'g','G' then Result.set_g
			when 'h','H' then Result.set_h
			when 'i','I' then Result.set_i
			when 'j','J' then Result.set_j
			when 'k','K' then Result.set_k
			when 'l','L' then Result.set_l
			when 'm','M' then Result.set_m
			when 'n','N' then Result.set_n
			when 'o','O' then Result.set_o
			when 'p','P' then Result.set_p
			when 'q','Q' then Result.set_q
			when 'r','R' then Result.set_r
			when 's','S' then Result.set_s
			when 't','T' then Result.set_t
			when 'u','U' then Result.set_u
			when 'v','V' then Result.set_v
			when 'w','W' then Result.set_w
			when 'x','X' then Result.set_x
			when 'y','Y' then Result.set_y
			when 'z','Z' then Result.set_z
			end
		ensure
			is_copy: Result /= Void
		end

	control_x_accelerator (alpha: CHARACTER): ACCELERATOR is
			-- Create a classic control+letter accelerator based 
			-- on a virtual key (to avoid case sensitivity of
			-- character based accelerator).
		require
			alpha: is_alpha (alpha)
		do
			!!Result.make
			Result.set_control
			Result.set_virtual_key (ascii_to_vkey (alpha))
		ensure
			is_copy: Result /= Void
		end

	is_alpha (char: CHARACTER): BOOLEAN is
			-- Is character an a-z code? (case insensitive)
		do
			Result := (char >= 'a' and char <= 'z') or (char >= 'A' and char <= 'Z')
		end

end -- class KEYBOARD_ROUTINES
