-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Menu bar"
	interface: client

class MENU_BAR

inherit
	MENU
		end
	WIN_API
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (par: OVERLAPPED_WINDOW) is
			-- Create a menu bar, when set up, the menubar shall be attach-ed 
			-- to the parent window.
		require
			valid: par /= Void
		do
			initialize -- init MENU
			parent := par
			set_handle (wrt.win_menu_cbar)
		ensure
			done: is_valid
			keep_reference: par = parent
		end

feature -- Installation & Destruction

	attach is
			-- Attach menu bar to parent window, attachment should be done 
			-- when the menu is completed.
		require
			valid: is_valid
		do
			parent.set_menu (Current)
		end

feature -- Action(s)

	paint is
			-- Update a menu bar.
		require
			valid: is_valid
		do
			wrt.win_drawmenu (parent.handle)
		end


feature {NONE} -- Finalisation (internal)
	
	dispose is
			-- Low-level API free resource
		do
			-- Windows destroys the menu itself.
			handle := Invalid_handle
		end

end -- class MENU_BAR
