-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Keyboard
	description: "Virtual key"
	interface: client
	
class VIRTUAL_KEY

inherit
	WIN_API
		end

creation
	make

creation {WIN_EVENT}
	make_value

feature {CREATION_NONE} -- Creation
	
	make is
		do
			set_cancel
		end

feature {WIN_EVENT} -- (Internal) creation

	make_value (v: INTEGER) is
			-- Set Virtual Key value.
		do
			value := v
		end

feature {WIN_API} -- Virtual key value
	
	value: INTEGER
			-- value of the key, one of the constants

feature -- Status

	is_key_down: BOOLEAN is
			-- Is the key down?
		do
			Result := wrt.win_keystate (value)
		end

feature -- Keys

	is_cancel: BOOLEAN is do Result := value = Cancel end -- control
	is_backspace: BOOLEAN is do Result := value = Backspace end
	is_tab: BOOLEAN is do Result := value = Tab end
	is_clear: BOOLEAN is do Result := value = Clear end
	is_return: BOOLEAN is do Result := value = Return end
	is_shift: BOOLEAN is do Result := value = Shift end
	is_control: BOOLEAN is do Result := value = Control end
	is_alt: BOOLEAN is do Result := value = Alt end
	is_pause: BOOLEAN is do Result := value = Pause end
	is_caps_lock: BOOLEAN is do Result := value = Caps_lock end
	is_escape: BOOLEAN is do Result := value = Escape end
	is_space: BOOLEAN is do Result := value = Space end
	
	-- direction
	is_prior: BOOLEAN is do Result := value = Prior end
	is_next: BOOLEAN is do Result := value = Next end
	is_end: BOOLEAN is do Result := value = Endkey end
	is_home: BOOLEAN is do Result := value = Home end
	is_cursor_left: BOOLEAN is do Result := value = Left end
	is_cursor_up: BOOLEAN is do Result := value = Up end
	is_cursor_right: BOOLEAN is do Result := value = Right end
	is_cursor_down: BOOLEAN is do Result := value = Down end
	
	-- other control
	is_select: BOOLEAN is do Result := value = Selectkey end
	is_execute: BOOLEAN is do Result := value = Execute end
	is_snapshot: BOOLEAN is do Result := value = Snapshot end
	is_insert: BOOLEAN is do Result := value = Insert end
	is_delete: BOOLEAN is do Result := value = Delete end
	is_help: BOOLEAN is do Result := value = Help end
	
	-- Digits
	is_0: BOOLEAN is do Result := value = Key_0 end
	is_1: BOOLEAN is do Result := value = Key_1 end
	is_2: BOOLEAN is do Result := value = Key_2 end
	is_3: BOOLEAN is do Result := value = Key_3 end
	is_4: BOOLEAN is do Result := value = Key_4 end
	is_5: BOOLEAN is do Result := value = Key_5 end
	is_6: BOOLEAN is do Result := value = Key_6 end
	is_7: BOOLEAN is do Result := value = Key_7 end
	is_8: BOOLEAN is do Result := value = Key_8 end
	is_9: BOOLEAN is do Result := value = Key_9 end

	-- Letters
	is_a: BOOLEAN is do Result := value = Key_a end
	is_b: BOOLEAN is do Result := value = Key_b end
	is_c: BOOLEAN is do Result := value = Key_c end
	is_d: BOOLEAN is do Result := value = Key_d end
	is_e: BOOLEAN is do Result := value = Key_e end
	is_f: BOOLEAN is do Result := value = Key_f end
	is_g: BOOLEAN is do Result := value = Key_g end
	is_h: BOOLEAN is do Result := value = Key_h end
	is_i: BOOLEAN is do Result := value = Key_i end
	is_j: BOOLEAN is do Result := value = Key_j end
	is_k: BOOLEAN is do Result := value = Key_k end
	is_l: BOOLEAN is do Result := value = Key_l end
	is_m: BOOLEAN is do Result := value = Key_m end
	is_n: BOOLEAN is do Result := value = Key_n end
	is_o: BOOLEAN is do Result := value = Key_o end
	is_p: BOOLEAN is do Result := value = Key_p end
	is_q: BOOLEAN is do Result := value = Key_q end
	is_r: BOOLEAN is do Result := value = Key_r end
	is_s: BOOLEAN is do Result := value = Key_s end
	is_t: BOOLEAN is do Result := value = Key_t end
	is_u: BOOLEAN is do Result := value = Key_u end
	is_v: BOOLEAN is do Result := value = Key_v end
	is_w: BOOLEAN is do Result := value = Key_w end
	is_x: BOOLEAN is do Result := value = Key_x end
	is_y: BOOLEAN is do Result := value = Key_y end
	is_z: BOOLEAN is do Result := value = Key_z end

	-- Numeric pad
	is_numpad_0: BOOLEAN is do Result := value = Numpad_0 end
	is_numpad_1: BOOLEAN is do Result := value = Numpad_1 end
	is_numpad_2: BOOLEAN is do Result := value = Numpad_2 end
	is_numpad_3: BOOLEAN is do Result := value = Numpad_3 end
	is_numpad_4: BOOLEAN is do Result := value = Numpad_4 end
	is_numpad_5: BOOLEAN is do Result := value = Numpad_5 end
	is_numpad_6: BOOLEAN is do Result := value = Numpad_6 end
	is_numpad_7: BOOLEAN is do Result := value = Numpad_7 end
	is_numpad_8: BOOLEAN is do Result := value = Numpad_8 end
	is_numpad_9: BOOLEAN is do Result := value = Numpad_9 end
	is_multiply: BOOLEAN is do Result := value = Multiply end
	is_add: BOOLEAN is do Result := value = Add end
	is_separator: BOOLEAN is do Result := value = Separator end
	is_sustract: BOOLEAN is do Result := value = Substract end
	is_decimal: BOOLEAN is do Result := value = Decimal end
	is_divide: BOOLEAN is do Result := value = Divide end

	-- function keys
	is_fkey_1: BOOLEAN is do Result := value = Fkey1 end
	is_fkey_2: BOOLEAN is do Result := value = Fkey2 end
	is_fkey_3: BOOLEAN is do Result := value = Fkey3 end
	is_fkey_4: BOOLEAN is do Result := value = Fkey4 end
	is_fkey_5: BOOLEAN is do Result := value = Fkey5 end
	is_fkey_6: BOOLEAN is do Result := value = Fkey6 end
	is_fkey_7: BOOLEAN is do Result := value = Fkey7 end
	is_fkey_8: BOOLEAN is do Result := value = Fkey8 end
	is_fkey_9: BOOLEAN is do Result := value = Fkey9 end
	is_fkey_10: BOOLEAN is do Result := value = Fkey10 end
	is_fkey_11: BOOLEAN is do Result := value = Fkey11 end
	is_fkey_12: BOOLEAN is do Result := value = Fkey12 end
	is_fkey_13: BOOLEAN is do Result := value = Fkey13 end
	is_fkey_14: BOOLEAN is do Result := value = Fkey14 end
	is_fkey_15: BOOLEAN is do Result := value = Fkey15 end
	is_fkey_16: BOOLEAN is do Result := value = Fkey16 end
	is_fkey_17: BOOLEAN is do Result := value = Fkey17 end
	is_fkey_18: BOOLEAN is do Result := value = Fkey18 end
	is_fkey_19: BOOLEAN is do Result := value = Fkey19 end
	is_fkey_20: BOOLEAN is do Result := value = Fkey20 end
	is_fkey_21: BOOLEAN is do Result := value = Fkey21 end
	is_fkey_22: BOOLEAN is do Result := value = Fkey22 end
	is_fkey_23: BOOLEAN is do Result := value = Fkey23 end
	is_fkey_24: BOOLEAN is do Result := value = Fkey24 end

	is_numlock: BOOLEAN is do Result := value = Numlock end
	is_scroll: BOOLEAN is do Result := value = Scroll end

feature -- Set keys

	set_cancel is do value := Cancel end -- control
	set_backspace is do value := Backspace end
	set_tab is do value := Tab end
	set_clear is do value := Clear end
	set_return is do value := Return end
	set_shift is do value := Shift end
	set_control is do value := Control end
	set_alt is do value := Alt end
	set_pause is do value := Pause end
	set_caps_lock is do value := Caps_lock end
	set_escape is do value := Escape end
	set_space is do value := Space end
	
	-- direction
	set_prior is do value := Prior end
	set_next is do value := Next end
	set_end is do value := Endkey end
	set_home is do value := Home end
	set_cursor_left is do value := Left end
	set_cursor_up is do value := Up end
	set_cursor_right is do value := Right end
	set_cursor_down is do value := Down end
	
	-- other control
	set_select is do value := Selectkey end
	set_execute is do value := Execute end
	set_snapshot is do value := Snapshot end
	set_insert is do value := Insert end
	set_delete is do value := Delete end
	set_help is do value := Help end
	
	-- Digits
	set_0 is do value := Key_0 end
	set_1 is do value := Key_1 end
	set_2 is do value := Key_2 end
	set_3 is do value := Key_3 end
	set_4 is do value := Key_4 end
	set_5 is do value := Key_5 end
	set_6 is do value := Key_6 end
	set_7 is do value := Key_7 end
	set_8 is do value := Key_8 end
	set_9 is do value := Key_9 end

	-- Letters
	set_a is do value := Key_a end
	set_b is do value := Key_b end
	set_c is do value := Key_c end
	set_d is do value := Key_d end
	set_e is do value := Key_e end
	set_f is do value := Key_f end
	set_g is do value := Key_g end
	set_h is do value := Key_h end
	set_i is do value := Key_i end
	set_j is do value := Key_j end
	set_k is do value := Key_k end
	set_l is do value := Key_l end
	set_m is do value := Key_m end
	set_n is do value := Key_n end
	set_o is do value := Key_o end
	set_p is do value := Key_p end
	set_q is do value := Key_q end
	set_r is do value := Key_r end
	set_s is do value := Key_s end
	set_t is do value := Key_t end
	set_u is do value := Key_u end
	set_v is do value := Key_v end
	set_w is do value := Key_w end
	set_x is do value := Key_x end
	set_y is do value := Key_y end
	set_z is do value := Key_z end

	-- Numeric pad
	set_numpad_0 is do value := Numpad_0 end
	set_numpad_1 is do value := Numpad_1 end
	set_numpad_2 is do value := Numpad_2 end
	set_numpad_3 is do value := Numpad_3 end
	set_numpad_4 is do value := Numpad_4 end
	set_numpad_5 is do value := Numpad_5 end
	set_numpad_6 is do value := Numpad_6 end
	set_numpad_7 is do value := Numpad_7 end
	set_numpad_8 is do value := Numpad_8 end
	set_numpad_9 is do value := Numpad_9 end
	set_multiply is do value := Multiply end
	set_add is do value := Add end
	set_separator is do value := Separator end
	set_sustract is do value := Substract end
	set_decimal is do value := Decimal end
	set_divide is do value := Divide end

	-- function keys
	set_fkey_1 is do value := Fkey1 end
	set_fkey_2 is do value := Fkey2 end
	set_fkey_3 is do value := Fkey3 end
	set_fkey_4 is do value := Fkey4 end
	set_fkey_5 is do value := Fkey5 end
	set_fkey_6 is do value := Fkey6 end
	set_fkey_7 is do value := Fkey7 end
	set_fkey_8 is do value := Fkey8 end
	set_fkey_9 is do value := Fkey9 end
	set_fkey_10 is do value := Fkey10 end
	set_fkey_11 is do value := Fkey11 end
	set_fkey_12 is do value := Fkey12 end
	set_fkey_13 is do value := Fkey13 end
	set_fkey_14 is do value := Fkey14 end
	set_fkey_15 is do value := Fkey15 end
	set_fkey_16 is do value := Fkey16 end
	set_fkey_17 is do value := Fkey17 end
	set_fkey_18 is do value := Fkey18 end
	set_fkey_19 is do value := Fkey19 end
	set_fkey_20 is do value := Fkey20 end
	set_fkey_21 is do value := Fkey21 end
	set_fkey_22 is do value := Fkey22 end
	set_fkey_23 is do value := Fkey23 end
	set_fkey_24 is do value := Fkey24 end

	set_numlock is do value := Numlock end
	set_scroll is do value := Scroll end

feature {NONE} -- Win32 Key Constants
	
	-- control
	Cancel: INTEGER is 3 -- control-break
	Backspace: INTEGER is 8
	Tab: INTEGER is 9
	Clear: INTEGER is 12
	Return: INTEGER is 13
	Shift: INTEGER is 16
	Control: INTEGER is 17
	Alt: INTEGER is 18
	Pause: INTEGER is 19
	Caps_lock: INTEGER is 20
	Escape: INTEGER is 27
	Space: INTEGER is 32
	-- direction
	Prior: INTEGER is 33 -- pageup
	Next: INTEGER is 34 -- pagedown
	Endkey: INTEGER is 35
	Home: INTEGER is 36
	Left: INTEGER is 37
	Up: INTEGER is 38
	Right: INTEGER is 39
	Down: INTEGER is 40
	
	-- other control
	Selectkey: INTEGER is 41
	Execute: INTEGER is 43
	Snapshot: INTEGER is 44 -- printscreen
	Insert: INTEGER is 45
	Delete: INTEGER is 46
	Help: INTEGER is 47 -- ?
	
	-- Digits
	Key_0: INTEGER is 48
	Key_1: INTEGER is 49
	Key_2: INTEGER is 50
	Key_3: INTEGER is 51
	Key_4: INTEGER is 52
	Key_5: INTEGER is 53
	Key_6: INTEGER is 54
	Key_7: INTEGER is 55
	Key_8: INTEGER is 56
	Key_9: INTEGER is 57
	
	-- Letters
	Key_a: INTEGER is 65
	Key_b: INTEGER is 66
	Key_c: INTEGER is 67
	Key_d: INTEGER is 68
	Key_e: INTEGER is 69
	Key_f: INTEGER is 70
	Key_g: INTEGER is 71
	Key_h: INTEGER is 72
	Key_i: INTEGER is 73
	Key_j: INTEGER is 74
	Key_k: INTEGER is 75
	Key_l: INTEGER is 76
	Key_m: INTEGER is 77
	Key_n: INTEGER is 78
	Key_o: INTEGER is 79
	Key_p: INTEGER is 80
	Key_q: INTEGER is 81
	Key_r: INTEGER is 82
	Key_s: INTEGER is 83
	Key_t: INTEGER is 84
	Key_u: INTEGER is 85
	Key_v: INTEGER is 86
	Key_w: INTEGER is 87
	Key_x: INTEGER is 88
	Key_y: INTEGER is 89
	Key_z: INTEGER is 90

	-- Numeric pad
	Numpad_0: INTEGER is 96
	Numpad_1: INTEGER is 97
	Numpad_2: INTEGER is 98
	Numpad_3: INTEGER is 99
	Numpad_4: INTEGER is 100
	Numpad_5: INTEGER is 101
	Numpad_6: INTEGER is 102
	Numpad_7: INTEGER is 103
	Numpad_8: INTEGER is 104
	Numpad_9: INTEGER is 105
	Multiply: INTEGER is 106
	Add: INTEGER is 107
	Separator: INTEGER is 108
	Substract: INTEGER is 109
	Decimal: INTEGER is 110 -- .
	Divide: INTEGER is 111

	-- function keys
	Fkey1: INTEGER is 112
	Fkey2: INTEGER is 113
	Fkey3: INTEGER is 114
	Fkey4: INTEGER is 115
	Fkey5: INTEGER is 116
	Fkey6: INTEGER is 117
	Fkey7: INTEGER is 118
	Fkey8: INTEGER is 119
	Fkey9: INTEGER is 120
	Fkey10: INTEGER is 121
	Fkey11: INTEGER is 122
	Fkey12: INTEGER is 123
	Fkey13: INTEGER is 124
	Fkey14: INTEGER is 125
	Fkey15: INTEGER is 126
	Fkey16: INTEGER is 127
	Fkey17: INTEGER is 128
	Fkey18: INTEGER is 129
	Fkey19: INTEGER is 130
	Fkey20: INTEGER is 131
	Fkey21: INTEGER is 132
	Fkey22: INTEGER is 133
	Fkey23: INTEGER is 134
	Fkey24: INTEGER is 135

	Numlock: INTEGER is 144
	Scroll: INTEGER is 145 -- scroll lock

end -- class VIRTUAL_KEY

