-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Xcontrols
	description: "Child windows stacked on each other in a direction"
	interface: client

class HORIZONTAL_STACK_WINDOW

inherit
	VERTICAL_STACK_WINDOW
		redefine
			when_resized
		end

creation
	make

feature {PUBLIC_NONE}
	
	when_resized is
			-- Window has been resized.
		local
			tmps, cs: RECTANGLE
			up, down, tmp_pt: POINT
			middle, actual: INTEGER
		do
			cs := client_size
			!! up.make
			!! down.make --_coord (cs.upper.x, cs.upper.y)
			
			if not cs.is_thin then
			
				if first /= Void then
					tmps := first.size
					if tmps.width > cs.upper.x then -- enough space?
						first.hide
						-- up is (0, 0)
					else
						up.set_x (tmps.width)
						!! tmp_pt.make
						tmps.translate_lower (tmp_pt)
						tmps.set_height (cs.height)
						first.set_size (tmps)
						if not first.is_visible then first.show end
					end
				end

				down.set_x (cs.upper.x)
				down.set_y (cs.upper.y)

				if last /= Void then
					tmps := last.size
					if tmps.width > (cs.upper.x - up.x) then -- enough space?
						last.hide
					else
						down.set_x (cs.upper.x - tmps.width + 1)
						!! tmp_pt.make_coord (down.x, 0)
						tmps.translate_lower (tmp_pt)
						tmps.set_height (cs.height)
						last.set_size (tmps)
						if not last.is_visible then last.show end
					end
				end

				if variable /= Void then
					if down.x < up.x then -- nothing left
						variable.hide
					else
						set_and_show (variable, up, down)
					end
				end
			end -- not thin
		end

end

